!= Module StoreDensCloud
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storedenscloud_2d-5.f90,v 1.1 2011-02-23 17:20:13 yamasita Exp $ 
! Tag Name::  $Name: arare4-20110328 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! * ̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼(ʬŷ׻). 
! * tendency  x,z,t δؿ
! * tendency λˡѹ
!   * û֥롼¤, ʿ̤ݴɤ褦ѹ
! * fillnegative ᤭줺ˤʤ˰ᤷ̤¸٤
!   ֥롼ɲ
! * Ѳ̤ǤϤʤ, ѲΨϤ褦.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StoreDensCloud
  !
  !̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeLong, & ! Ĺ֥ƥå
    &                  DelTimeShort   ! û֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StoreDensCloud_Init, StoreDensCloudMean, StoreDensCloudClean
  public xz_DensCloudAdv, xz_DensCloudTurb, xz_DensCloudDiff, &
    &    xz_DensCloudCond, xz_DensCloudFill, xz_DensCloudFillZero
  public xz_DensCloudAdv2, xz_DensCloudTurb2, xz_DensCloudDiff2, &
    &    xz_DensCloudCond2, xz_DensCloudFill2, xz_DensCloudFillZero2
  public StoreDensCloudAdv,  StoreDensCloudTurb, StoreDensCloudDiff, &
    &    StoreDensCloudCond, StoreDensCloudFill, StoreDensCloudFillZero
  public DensCloudAdvTendSum, DensCloudTurbTendSum, DensCloudDiffTendSum, &
    &    DensCloudCondTendSum, DensCloudFillTendSum, DensCloudFillZeroTendSum


  !ѿ
  real(8), allocatable :: z_DensCloudAdv(:)
  real(8), allocatable :: z_DensCloudTurb(:)
  real(8), allocatable :: z_DensCloudDiff(:)
  real(8), allocatable :: z_DensCloudCond(:)
  real(8), allocatable :: z_DensCloudFill(:)
  real(8), allocatable :: z_DensCloudFillZero(:)
  real(8), allocatable :: xz_DensCloudAdv(:,:)
  real(8), allocatable :: xz_DensCloudTurb(:,:)
  real(8), allocatable :: xz_DensCloudDiff(:,:)
  real(8), allocatable :: xz_DensCloudCond(:,:)
  real(8), allocatable :: xz_DensCloudFill(:,:)
  real(8), allocatable :: xz_DensCloudFillZero(:,:)
  real(8), allocatable :: xz_DensCloudAdv2(:,:)
  real(8), allocatable :: xz_DensCloudTurb2(:,:)
  real(8), allocatable :: xz_DensCloudDiff2(:,:)
  real(8), allocatable :: xz_DensCloudCond2(:,:)
  real(8), allocatable :: xz_DensCloudFill2(:,:)
  real(8), allocatable :: xz_DensCloudFillZero2(:,:)

  !save °
  save xz_DensCloudAdv, xz_DensCloudTurb, xz_DensCloudDiff
  save xz_DensCloudCond, xz_DensCloudFill, xz_DensCloudFillZero
  save xz_DensCloudAdv2, xz_DensCloudTurb2, xz_DensCloudDiff2
  save xz_DensCloudCond2, xz_DensCloudFill2, xz_DensCloudFillZero2
  save z_DensCloudAdv, z_DensCloudTurb, z_DensCloudDiff
  save z_DensCloudCond, z_DensCloudFill, z_DensCloudFillZero

contains

  subroutine StoreDensCloud_Init( )
    !롼

    allocate(     &
      & z_DensCloudAdv(DimZMin:DimZMax),  & 
      & z_DensCloudTurb(DimZMin:DimZMax), &
      & z_DensCloudDiff(DimZMin:DimZMax), &
      & z_DensCloudCond(DimZMin:DimZMax), &
      & z_DensCloudFill(DimZMin:DimZMax), &
      & z_DensCloudFillZero(DimZMin:DimZMax), &
      & xz_DensCloudAdv(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & xz_DensCloudTurb(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudDiff(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudCond(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFill(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFillZero(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudAdv2(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & xz_DensCloudTurb2(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudDiff2(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudCond2(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFill2(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFillZero2(DimXMin:DimXMax, DimZMin:DimZMax)  &
      &  )

    call StoreDensCloudClean

  end subroutine StoreDensCloud_Init


  subroutine StoreDensCloudClean( )
    !ݴɤͤΥꥢ
    
    z_DensCloudAdv  = 0.0d0
    z_DensCloudTurb = 0.0d0
    z_DensCloudDiff = 0.0d0
    z_DensCloudCond = 0.0d0
    z_DensCloudFill = 0.0d0
    z_DensCloudFillZero = 0.0d0

    xz_DensCloudAdv  = 0.0d0
    xz_DensCloudTurb = 0.0d0
    xz_DensCloudDiff = 0.0d0
    xz_DensCloudCond = 0.0d0
    xz_DensCloudFill = 0.0d0
    xz_DensCloudFillZero = 0.0d0

    xz_DensCloudAdv2  = 0.0d0
    xz_DensCloudTurb2 = 0.0d0
    xz_DensCloudDiff2 = 0.0d0
    xz_DensCloudCond2 = 0.0d0
    xz_DensCloudFill2 = 0.0d0
    xz_DensCloudFillZero2 = 0.0d0
   
!    CalNum  = 1.0d-40    !ػ. 
  end subroutine StoreDensCloudClean


  subroutine StoreDensCloudMean( )

    !ݴɤͤοʿʿ [K/s]
    real(8) :: CalNumShort

    CalNumShort = 2.0d0 * DelTimeLong / DelTimeShort
    
    
    xz_DensCloudAdv  =  xz_DensCloudAdv    / ( CalNumShort * TimeDisp )
    xz_DensCloudTurb =  xz_DensCloudTurb   / ( CalNumShort * TimeDisp )
    xz_DensCloudDiff =  xz_DensCloudDiff   / ( CalNumShort * TimeDisp )
    xz_DensCloudCond =  xz_DensCloudCond   / ( CalNumShort * TimeDisp )
    xz_DensCloudFill =  xz_DensCloudFill   / ( CalNumShort * TimeDisp )
    xz_DensCloudFillZero =  xz_DensCloudFillZero   / ( CalNumShort * TimeDisp )

  end subroutine StoreDensCloudMean


  subroutine StoreDensCloudAdv( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_DensCloudAdv + Work
    xz_DensCloudAdv = Work2

  end subroutine StoreDensCloudAdv


  subroutine StoreDensCloudTurb( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudTurb + Work
    xz_DensCloudTurb = Work2

  end subroutine StoreDensCloudTurb


  subroutine StoreDensCloudDiff( Work )
    !ͳȻݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudDiff + Work
    xz_DensCloudDiff = Work2

  end subroutine StoreDensCloudDiff

  subroutine StoreDensCloudCond( Work )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudCond + Work
    xz_DensCloudCond = Work2

  end subroutine StoreDensCloudCond

  subroutine StoreDensCloudFill( Work )
    !ץˤѲ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFill
    xz_DensCloudFill = Work2

  end subroutine StoreDensCloudFill

  subroutine StoreDensCloudFillZero( Work )
    !ץˤѲ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFillZero
    xz_DensCloudFillZero = Work2

  end subroutine StoreDensCloudFillZero


  subroutine DensCloudAdvTendSum( Work )
    ! 2 \delta t γƻǵ᤿ή tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_DensCloudAdv2 + Work
    xz_DensCloudAdv2 = Work2

    xz_DensCloudAdv = 0.0d0

  end subroutine DensCloudAdvTendSum

  subroutine DensCloudTurbTendSum( Work )
    ! 2 \delta t γƻǵ᤿ή tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudTurb2 + Work
    xz_DensCloudTurb2 = Work2

    xz_DensCloudTurb = 0.0d0

  end subroutine DensCloudTurbTendSum

  subroutine DensCloudDiffTendSum( Work )
    ! 2 \delta t γƻǵ᤿ͳȻ tendency ­.
    ! û֥ƥåפΥ롼˹Ԥ xz_DensCloudxxx  ̤
    ! ꥢƤ.

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudDiff2 + Work
    xz_DensCloudDiff2 = Work2

    xz_DensCloudDiff = 0.0d0

  end subroutine DensCloudDiffTendSum

  subroutine DensCloudCondTendSum( Work )
    ! 2 \delta t γƻǵ᤿ǮǮ tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudCond2 + Work
    xz_DensCloudCond2 = Work2

    xz_DensCloudCond = 0.0d0

  end subroutine DensCloudCondTendSum

  subroutine DensCloudFillTendSum( Work )
    ! 2 \delta t γƻǵ᤿ tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFill2
    xz_DensCloudFill2 = Work2

    xz_DensCloudFill = 0.0d0

  end subroutine DensCloudFillTendSum

  subroutine DensCloudFillZeroTendSum( Work )
    ! 2 \delta t γƻǵ᤿ tendency ­

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFillZero2
    xz_DensCloudFillZero2 = Work2

    xz_DensCloudFillZero = 0.0d0

  end subroutine DensCloudFillZeroTendSum


  function a_MeanX_aa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: a_MeanX_aa(DimZMin:DimZMax)
                                     !ʿʿ

    a_MeanX_aa = sum( var(RegXMin+1:RegXMax, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function a_MeanX_aa
  

end module StoreDensCloud
